Subject: Re: [PATCH net-next RFC v2 1/3] lwt: infrastructure to support light weight tunnels

From: roopa <[email-masked]>
Date: Sat, 20 Jun 2015 07:27:25 -0700

On 6/19/15, 11:39 AM, Robert Shearman wrote:
> On 19/06/15 19:34, roopa wrote:
>> On 6/19/15, 10:25 AM, Robert Shearman wrote:
>>> n 19/06/15 16:14, roopa wrote:
>>>
>> In the netdevice case, this output function is not called atall. It
>> should just follow the existing netdevice the route is pointing to.
>
> Sorry for not being clear, but I meant that there would have to be 
> lwtunnel_skb_lwstate functions for ipv4 and ipv6 to match the output 
> functions. So in the vxlan use case where it's using a netdevice, how 
> would it determine which one to call?

thanks for that clarification, and good point. I see some areas of the 
kernel checking for skb->protocol to do the conversion (something like 
below). I am guessing that is acceptable.
if (skb->protocol == htons(ETH_P_IPV6))
                 struct rt6_info *rt6 = (struct rt6_info *)skb_dst(skb);